Add a pin button to the RevisionSlider
Closed, ResolvedPublic5 Story Points

Description

T141871 adds a bar to show and hide the revisionSlider.

Task: Add a possibility to "pin" the revisionSlider, leaving it open for every time you visit this page - unless you unpin it again. The pin should be part of the revisionSlider bar.

Background:
This is part of adding the revision slider to the revision diff page. The revision slider is a feature that adds a visualization of all revisions to the compare screen.
The revision slider was originally prototyped by the WMF Community Tech team and then handed over to the WMDE TCB team, as it is also a solution to fulfill a wish of the German Community Wishlist: https://de.wikipedia.org/wiki/Wikipedia:Umfragen/Technische_W%C3%BCnsche_2015/Artikel#Anzeige_aller_Bearbeitungskommentare_im_Diff

Lea_WMDE created this task.Aug 5 2016, 12:44 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptAug 5 2016, 12:44 PM
Lea_WMDE updated the task description. (Show Details)
Restricted Application added a project: Design. · View Herald TranscriptAug 5 2016, 12:50 PM
Lea_WMDE moved this task from Incoming to Revision Slider on the TCB-Team board.Aug 8 2016, 3:02 PM

Few things and questions related to UI that came to my mind:

  • there does not seem to be a "pin" icon in OO-UI icon set: https://doc.wikimedia.org/oojs-ui/master/demos/#icons-mediawiki-ltr We could either use another icon or create the icon (and possibly add it to OOUI?)
  • where should be the icon placed? If next to collapse/expand button, what should happen to the pin button when user collapses RevisionSlider? Should it disappear and re-appear if Slider gets expanded again?
  • should the user be able to collapse (hide) RevisionSlider once it is pinned?
  • How the icon should represent the "pinned" state?

Here's a quick idea of how the pins could look. They can still be optimized to fit the overall look of the OO-UI icons more.


Do I understand correctly, that the pinning would be something like a setting specific to the user and wouldn't change ever unless un-pinned? If so, these are my suggestions:

  • where should be the icon placed? If next to collapse/expand button, what should happen to the pin button when user collapses RevisionSlider? Should it disappear and re-appear if Slider gets expanded again?

I suggest to put the pin on the left of the expand/collaps icon. Maybe 10px apart or so?
I don't think it should dissapear and re-appear, depending on whether the slider is collapsed or not. The user should be able to see at a glance whether the slider is pinned or not.

  • should the user be able to collapse (hide) RevisionSlider once it is pinned?

Clear yes to me. Removing that possibility would also remove flexibility for the user. They would always have to unpin first, before collapsing, possibly then forgetting to pin it again later. Whether it is collapsed or not for each single case should be separate from their overall wish to generally have it collapsed or expanded.

Thanks for thinking about those things. I believe we know now how to move forward with this.

Do I understand correctly, that the pinning would be something like a setting specific to the user and wouldn't change ever unless un-pinned?

Yes! So all you said is perfectly valid and makes a lot of sense.

Charlie_WMDE moved this task from Incoming to Doing on the WMDE-Design board.Aug 10 2016, 3:10 PM
Lea_WMDE moved this task from Incoming to Doing on the Revision-Slider board.Aug 10 2016, 3:34 PM

Icon: Looks fine to me. We should check back with the OOJS people.

Mock: Here is what it would look collapsed:

Which should adhere the the bahavior of flyouts in Photoshop, Corel Draw etc. (Do they still have them?!)

Behaviour once pinned
I suppose that if the user pinned the slider, it will save the state (no matter if the user expands or collapses the slider in between, it will open with whatever the state before was), if it is unpinned, it will do in whatever the default is on the next (re) load.

In desktop applications the "pinning" is usually a bit different, there it means: Show this always (pinned) or show only if a specific tool/object class is selected. (At least that is what Blender does and what Corel Draw did)

WMDE-leszek triaged this task as Normal priority.Aug 11 2016, 3:13 PM

Change 304842 had a related patch set uploaded (by WMDE-leszek):
WIP Add button to have revision slider expanded automatically

https://gerrit.wikimedia.org/r/304842

Jan_Dittrich moved this task from Doing to Done on the WMDE-Design board.Aug 30 2016, 12:17 PM

Change 304842 merged by jenkins-bot:
Add button to have revision slider expanded automatically

https://gerrit.wikimedia.org/r/304842

WMDE-leszek closed this task as Resolved.Sep 8 2016, 8:40 AM
Addshore moved this task from Doing to Done on the Revision-Slider board.Sep 13 2016, 2:49 PM